namespace WarmlyShip
{
    public partial class FormShip : Form
    {
        private DrawningWarmlyShip _ship;
        public FormShip()
        {
            InitializeComponent();
        }
        private void Draw()
        {
            Bitmap bmp = new(pictureBoxShip.Width, pictureBoxShip.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _ship?.DrawTransport(gr);
            pictureBoxShip.Image = bmp;
        }
        /// <summary>
        ///    ""
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new();
            _ship = new DrawningWarmlyShip();
            _ship.Init(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            _ship.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxShip.Width, pictureBoxShip.Height);
            toolStripStatusLabelSpeed.Text = $": {_ship.Ship.Speed}";
            toolStripStatusLabelWeight.Text = $": {_ship.Ship.Weight}";
            toolStripStatusLabelBodyColor.Text = $": {_ship.Ship.BodyColor.Name}";
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //  
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _ship?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _ship?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _ship?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _ship?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
    }
}